#!/usr/bin/python
#Copyright Bob Blair, 2010-2012
#Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, distribute with modifications, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
#The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
#
#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#
#Except as contained in this notice, the name(s) of the above copyright holders shall not be used in advertising or otherwise to promote the sale, use or other dealings in this Software without prior written authorization.
#

# Check the contents of the formatted index to make sure line data is sane

import sys
import re
from indexutil import slist, roman2int


plist = [];
for s in slist:
 plist.append(re.compile(s))
f = open(sys.argv[1])
index = f.readlines();
f.close()
lineno = 0
itemno = 0
subject = ""
subjectcnt = 0
lastvol = 0
lastpage = 0
for line in index:
 lineno = lineno + 1
 m = re.match(plist[5], line) # check blank line
 if (m):
  continue
 m = re.match(plist[0], line) # check start of subject
 if (m):
  subject = line
  subjectcnt = subjectcnt + 1
  itemno = 0
  lastvol = 0
  lastpage = 0
  continue
 m = re.match(plist[1], line) # check "See xxx"
 if m:
  itemno = itemno + 1
  continue
 m = re.match(plist[2], line) # check "xxx ib."
 if m:
  if itemno == 0:
   print 'Line', lineno, 'first item is ibid.'
  itemno = itemno + 1
  continue
 m = re.match(plist[3], line) # check "xxx iii. 99"
 if m:
  itemno = itemno + 1
  vol = roman2int(m.group(2))
  if vol < lastvol:
   print 'Line', lineno, 'Volume out of order'
  page = int(m.group(3))
  lastvol = vol
  lastpage = page
  continue
 m = re.match(plist[4], line) # check xxxx 99
 if (m):
  if itemno == 0:
   print 'Line', lineno, 'No volume for first item'
  itemno = itemno + 1
  page = int(m.group(2))
  if page < lastpage:
   print 'Line', lineno, 'Page numbers out of order:', page, lastpage
  lastpage = page
  continue
 print 'Line', lineno, 'Unparseable line.'
print "Processed", lineno, "lines for", subjectcnt, "subjects"
