#!/bin/python
#Copyright Bob Blair, 2010-2012
#Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, distribute with modifications, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
#The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
#
#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#
#Except as contained in this notice, the name(s) of the above copyright holders shall not be used in advertising or otherwise to promote the sale, use or other dealings in this Software without prior written authorization.
#

# Data and utilities for dealing with Gardiner's History of England index

#
# These are the regex patterns of lines in the text representation of
# the index
#

slist = ["  (.+)$",
         " *See (.+) *$",
         "([^<].+) ib. *$",
         "([^<].+) +([ivx]+)\. +([0-9]+) *$",
         "([^<].+) +([0-9]+) *$",
         " *$"]

#
# URLs for the 10 volumes of the history
#
baseurl = 'http://books.google.com/books'
volidlist = [
              'k10NAAAAIAAJ', #Vol 1
              'ejoIAAAAQAAJ', #Vol 2
              'ljcOAAAAYAAJ', #Vol 3
              '5jcOAAAAYAAJ', #Vol 4
              'ZGINAAAAIAAJ', #Vol 5
              'Pt8QAAAAYAAJ', #Vol 6
              #'GUkJAAAAIAAJ', #Vol 7
              'X2MNAAAAIAAJ', #Vol 7
              'G2INAAAAIAAJ', #Vol 8
              '6oIJAAAAIAAJ', #Vol 9
              '3WINAAAAIAAJ'] #Vol 10

#
# A function that returns the URL associated with a particular volume and page
#
def getURL(vol, page):
 s = ''
 vol = int(vol)
 if vol > 0 & vol < 11:
  s = baseurl + '?id=' + volidlist[vol-1] + '&amp;pg=PA' + str(page)
 return s


#
# This function converts roman volume numbers to the equivalent integer
#
def roman2int(s):
 ret = 0
 if s == 'i':
  ret = 1
 elif s == 'ii':
  ret = 2
 elif s == 'iii':
  ret = 3
 elif s == 'iv':
  ret = 4
 elif s == 'v':
  ret = 5
 elif s == 'vi':
  ret = 6
 elif s == 'vii':
  ret = 7
 elif s == 'viii':
  ret = 8
 elif s == 'ix':
  ret = 9
 elif s == 'x':
  ret = 10
 return ret
